// \EXAMPLES\EX08031.H
// definition of the class String
//--------------------------------------------------------------

//  files in this example:
// EX08031.H         this file
// %F,15,EX08032.H%EX08032.H         definition of class PhoneBk
// %F,15,EX08031.CPP%EX08031.CPP   member functions of String
// %F,15,EX08032.CPP%EX08032.CPP   member function of PhoneBk
// %F,15,EX0803.CPP%EX0803.CPP   main() to exercise PhoneBk Class

//--------------------------------------------------------------
#ifndef STRCLASS_H
#define STRCLASS_H

#include <iostream.h>         // needed or output stream

class String {                // data members
  char* text;                    // pointer to the characters
  int len;                       // number of chars in String
  int size;                      // allocated space for chars
public:                          // member functions
  String(int maxlen = 0);             // default constructor
  String( const String& s);           // copy constuctor
  String( char* s);                   // convert  char* to String
  ~String();                          // destructor
  int compare(const char* t) const;   // compare string to char*
  void append( const char* t);        // add chars to a String
  ostream& print(ostream& os) const;  // print chars in a String
  String& operator=( const String& s);// assignment operator
};

#endif
