// \EXAMPLES\EX08051.H
// a sample class using dynamic memory - String
//--------------------------------------------------------------

//  files in this example:
// EX08051.H       this file
// %F,15,EX08052.H%EX08052.H       definition of classes PhoneBk,
//                  List, and PhoneNum
// %F,15,EX08051.CPP%EX08051.CPP     member functions of String
// %F,15,EX08052.CPP%EX08052.CPP     member functions of PhoneBk
//                  List, and PhoneNum
// %F,15,EX0805.CPP%EX0805.CPP   main() to exercise PhoneBk

//--------------------------------------------------------------
#ifndef STRCLASS_H
#define STRCLASS_H

#include <iostream.h>         // needed or output stream

//--------------------------------------------------------------
class String {                // data members
  char* text;                    // pointer to the characters
  int len;                       // number of chars in String
  int size;                      // allocated space for chars
public:                          // member functions
  String(int maxlen = 0);             // default constructor
  String( const String& s);           // copy constuctor
  String( char* s);                   // convert  char* to String
  ~String();                          // destructor
  int compare(const char* t) const;   // compare string to char*
  void append( const char* t);        // add chars to a String
  ostream& print(ostream& os) const;  // print chars in a String
  String& operator=( const String& s);// assignment operator
};

#endif
